-- these are all still very experimental,
-- but they should at least give you a head-start.
local presets = {}

local function make_preset(cfg)
    local name = cfg.name
    if name ~= nil then
        cfg.log_fn = cfg.log_fn or 'logs-'..name..'.csv'
        cfg.params_fn = cfg.params_fn or 'params-'..name..'.txt'
    end
    presets[name] = cfg
    return cfg
end

make_preset{
    name = 'big-scroll',

    starting_world = 1,
    starting_level = 1,
    start_big = true,
    starting_lives = 0,
    min_time = 300,
    max_time = 300,
    timer_loser = 1.0,

    decrement_reward = false,
    score_multiplier = 0,
}

make_preset{
    name = 'big-scroll-reduced',
    parent = 'big-scroll',

    init_zeros = true,

    reduce_tiles = true,
    bias_out = false,

    deterministic = false,
}

make_preset{
    name = 'big-scroll-hidden',
    parent = 'big-scroll',

    init_zeros = true,

    hidden = true,
    hidden_size = 64, --128,
    layernorm = true,
    reduce_tiles = false,
    bias_out = false,

    deterministic = false,
}

make_preset{
    name = 'snes',
    parent = 'big-scroll-hidden',

    es = 'snes',

    epoch_trials = 100,

    deviation = 0.5,
    negate_trials = false,
    min_refresh = 0.25,

    param_rate = 0.50,
    sigma_rate = 0.100, --0.125,
    param_decay = 0.006,
    sigma_decay = 0.008,
}

make_preset{
    name = 'xnes',
    parent = 'big-scroll-reduced',

    es = 'xnes',

    deviation = 0.5,
    negate_trials = false,

    epoch_trials = 50,

    param_rate = 1.0,
    sigma_rate = 0.01,
    covar_rate = 0.01,
}

make_preset{
    name = 'xnes2',
    parent = 'big-scroll-reduced',

    es = 'xnes',

    deviation = 0.1207,
    negate_trials = true,

    epoch_trials = 10,

    param_rate = 0.5,
    sigma_rate = 0.16,
    covar_rate = 0.04,
    param_decay = 0.004,
    sigma_decay = 0.00128,
}

make_preset{
    name = 'ars',
    parent = 'big-scroll-reduced',

    es = 'ars',
    epoch_top_trials = 20,
    deterministic = true,
    deviation = 0.01,
    epoch_trials = 20,
    param_rate = 0.368,
    param_decay = 0.0138,
    momentum = 0.5,
}

make_preset{
    name = 'play',

    playable_mode = true,
}

return presets
